//+------------------------------------------------------------------+
//|						             ea_.mq4 |
//|                                                             v0.1 |
//|								     |
//|				       last modified: 20091027.10:22 |
//+------------------------------------------------------------------+
/* ea_.mq4: ea_template2.mq4.
	:
	:
*/

/* ea_template2.mq4: mt4ܽģ.
	дSignal_OpenOrder(), ͿԷź.
	ƽдSignal_CloseOrder(), ͿԷƽź.

	Ҫͼ, ע͵tell_timeframe_3(), ԼصıPeriod_MultipleKLine_long_period.

Ŀ:
	ÿһ鶨, ֻҪ1νӯ, 鶨.
	ÿһ鶨, ʱֻһδƽ.
	ϴν׿ʱ, νӱ.

˼·
	һνӯ, i=0.
	һν, i++. i >= MaxTradeCount, i=0.

	ʼ֤		=	10,000ŷԪ.	(1Ԫ)
	ܸ˱		=	50.
	Tյ1ν׽	=	100Ԫ.
	iν׽		=	1ν׽ * 3 ^ i.
	ÿ״	=	9
	ÿ	=	ʼ֤5%.
	ǰֵĵֵ		=	0.0001

	һνӯ, i=0.
	һν, i++. i >= MaxTradeCount, i=0.
	MaxTradeCount = 9.
	MaxTradeLoss = 0.05.
*/

#property copyright "Copyright ?2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

// stlib.mqh, stderror.mqh: ErrorDescription()Ҫ
#include <stdlib.mqh>
#include <stderror.mqh>

#define TimeFrameLen    10

/*	DEBUG:			Ա־; 
	swap_Signal_Trade:	/ź, ;
	sleep_time:		ʱ(λ:); 
	MaxTradeCount:		ÿ״;
	MaxTradeLoss:		ÿʧ;
	open_lots:		ֵĳʼ(λ:); 
	open_pow_flag:		ν׿ӱı־. false: ʼΪֵĳʼ; true: , ´ν׼ӱ.
	open_pow_base:		pow()Ļ;  = ֵĳʼ * pow(open_pow_base, i_no).
*/
extern bool	DEBUG=false, swap_Signal_Trade=false;
extern int	sleep_time=1, MaxTradeCount=9;
extern double	MaxTradeLoss=0.05, open_lots=0.01;
extern bool	open_pow_flag=false;
extern double	open_pow_base=2.5;

/* ȫֱ.
	i_no:			һνӯ, i=0. һν, i++. i >= MaxTradeCount, i=0.
	ticket:			δƽĶ.
	loss:			ÿ齻׵ʧ.
*/
static int	i_no=0, ticket=-1, ordertype=-1;
static double	loss=0;

/* Signal_OpenOrder() ҪĲ.
	Period_Multiple:	k߷ʱ = ǰͼk߷ʱ * Period_Multiple.
	kLine_long_period:	k߷ʱ. mt4ܲṩ÷ʱ, ȡڵ(ǰͼk߷ʱ * Period_Multiple)ķʱ.
	Order_Comment:		ʶ. eaڹϻָ, ʶδƽ. ʹòظַ.
*/
/*
extern int	Period_Multiple=4;
int	KLine_long_period;
*/

string	Order_Comment="ea_template2";

/* Signal_CloseOrder() ҪĲ.
*/

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
	string	str;
	datetime	curr_time;
	double	x;

	curr_time = TimeCurrent();
	Debug(1, "===============================================================================");
	str = TimeToStr(curr_time) + ", init(): ";
	Debug(1, str);
	x = MarketInfo(Symbol(), MODE_MINLOT);
	if (open_lots < x)
		open_lots = x;
	str = "ǰͼϢ: Ҷ=" + Symbol() + ", =" + Period() + ", ֵ=" + DoubleToStr(Point, 5) + ", ǰҶԵĻСλ=" + Digits + ", ҵı׼ִС=" + DoubleToStr(MarketInfo(Symbol(), MODE_LOTSIZE), 5) + ", С׼=" + DoubleToStr(x, 5);
	Debug(1, str);
	str = "˻Ϣ: =" + AccountServer() + ", =" + AccountNumber() + ", =" + AccountName() + ", ܸ˱=" + AccountLeverage() + ", =" + DoubleToStr(AccountBalance(), 2) + ", õ=" + DoubleToStr(AccountCredit(), 2) + ", ˻õĻ=" + AccountCurrency() + ", ֵ=" + DoubleToStr(AccountEquity(), 2) + ", ֤=" + DoubleToStr(AccountMargin(), 2);
	Debug(1, str);
	str = "ʼ=" + DoubleToStr(open_lots, 5) + ", ÿĲִ=" + MaxTradeCount + ", ÿʧ=" + DoubleToStr(MaxTradeLoss * 100, 2) + "%, ֵĳʼ=" + DoubleToStr(open_lots, 5) + ", =";
	if (DEBUG == false)
		str = str + "false";
	else
		str = str + "true";
	str = str + ", ֵ=";
	if (open_pow_flag == false)
		str = str + "false";
	else
		str = str + "true, ֵ=" + DoubleToStr(open_lots, 5) + " * pow(" + DoubleToStr(open_pow_base, 2) + ", ִ)";
	Debug(1, str);

/*
	// ókͼʱ.
	KLine_long_period = Period() * Period_Multiple;
*/
	return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
	return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
	int x;
	bool flag=true;

	// 鶨ǷҪƽ.
	if (ticket > 0) {
		// 鶨ǷѾƽ. Ѿƽ, ׼һοֵĻϢ.
		flag = Check_Order();
		if (flag == true) {
			// öδƽ, ƽǷҪƽ.
			flag = Signal_CloseOrder();
			if (flag == true)
				// Ҫƽ, CloseOrder().
				CloseOrder();
		}
	}
	// ָ.
	if (ticket < 0) {
		x = Signal_OpenOrder();
		if (x != 0) {
			if (swap_Signal_Trade == true) 
				// .
				x = 0 - x;
			// .
			OpenOrder(x);
		}
	}
	// ʱ.
	Sleep(sleep_time * 1000);

	return(0);
}

//+------------------------------------------------------------------+
void Debug(int flag, string str) {
	if (DEBUG == true || flag != 0)
		Print(str);
}

bool OpenOrder(int type) {
// źtype, /.
	bool flag=true;
	int err;
	double volume, op, sl=0, tp=0, x; 
	string str, comment, market;
	datetime curr_time;

	curr_time = TimeCurrent();
	str = TimeToStr(curr_time) + ", OpenOrder(): i_no=" + i_no + ", ticket=" + ticket + ", type=";
	if (type < 0)
		str = str + "Sell";
	else if (type > 0)
		str = str + "Buy";
	Debug(1, str);
	// ʶ. eaڹϻָ, ʶδƽ. ʹòظַ.
	comment = Order_Comment;
	if (open_pow_flag == true)
		// ֵ.
		volume = open_lots * MathPow(open_pow_base, i_no);
	else
		// ֵ.
		volume = open_lots;
	market = Symbol();
	if (type < 0) {
		ordertype = OP_SELL;
		op = Bid;
		str = "Sell";
	} else if (type > 0) {
		ordertype = OP_BUY;
		op = Ask;
		str = "Buy";
	}
	// 鱣֤.
	if (AccountFreeMarginCheck(market, ordertype, volume) <= 0 || GetLastError() == ERR_NOT_ENOUGH_MONEY) {
		// ֤.
		flag = false;
		str = "OpenOrder(): Error! not enough money! ---- AccountFreeMarginCheck(): " + market + ", " + str + ", volume=" + DoubleToStr(volume, 5);
		Debug(-1, str);
		str = "AccountBalance=" + DoubleToStr(AccountBalance(), 5) + ", AccountCredit=" + DoubleToStr(AccountCredit(), 5) + ", AccountEquity=" + DoubleToStr(AccountEquity(), 5) + ", AccountFreeMargin=" + DoubleToStr(AccountFreeMargin(), 5) + ", AccountMargin=" + DoubleToStr(AccountMargin(), 5) + ", AccountProfit=" + DoubleToStr(AccountProfit(), 5);
		Debug(-1, str);
		// ź.
		i_no = 0;
		ticket = -1;
		loss = 0;
		flag = false;
		return(flag);
	}
	// ͽ.
	ticket = OrderSend(Symbol(), ordertype, volume, op, 3, sl, tp, comment, 0, CLR_NONE);
	if (ticket < 0) {
		// ʧ, Ϣ.
		err = GetLastError();
		str = "Error! OrderSend() fail. errno=" + err + "# " + ErrorDescription(err) + " ---- OrderSend(): " + Symbol() + ", " + str + ", volume=" + DoubleToStr(volume, 5) + ", op=" + DoubleToStr(op, 5) + ", sl=0.0, tp=0.0, comment=" + comment;
		Debug(-1, str);
		ticket = -1;
		flag = false;
	}

	return(flag);
}

bool Check_Order() {
// Check_Order(): ѾֵĶ, ǷѾƽ.
	datetime curr_time, closetime;
	double op, cp, x;
	string str;
	bool flag=false;

	curr_time = TimeCurrent();
	if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES) == false) {
		// ܼö. ´οʼµĽ.
		str = "Test! Check_Order(): don't find order. ticket=" + ticket;
		Debug(0, str);
		i_no = 0;
		ticket = -1;
		ordertype = -1;
		loss = 0;
	} else if (OrderCloseTime() != 0) {
		// öѾƽ, ׼һοֵĻϢ.
		op = OrderOpenPrice();
		cp = OrderClosePrice();
		ordertype = OrderType();
		if (ordertype == OP_SELL)
			x = op - cp;
		else if(ordertype == OP_BUY)
			x = cp - op;
		OrderPrint();
		str = TimeToStr(curr_time) + ", Check_Order(): closed order. i_no=" + i_no + ", ticket=" + ticket + ", profit=" + DoubleToStr(x / Point, 5);
		Debug(1, str);
		if (x < 0 && i_no < MaxTradeCount + 1) {
			// .
			i_no++;
			loss += x;
		} else  {
			// ӯ, ߴﵽ󲹲ִ.
			i_no = 0;
			loss = 0;
		}
		ticket = -1;
		ordertype = -1;
	} else
		// δƽ.
		flag = true;

	return(flag);
}

void CloseOrder() {
	bool flag;
	double cp, volume;
	int err;
	string str;

	OrderSelect(ticket, SELECT_BY_TICKET);
	ordertype = OrderType();
	if (ordertype == OP_SELL)
		cp = Ask;
	else if (ordertype == OP_BUY)
		cp = Bid;
	volume = OrderLots();
	flag = OrderClose(ticket, volume, cp, 3, CLR_NONE);
	if (flag == false) {
		// ƽʧ.
		err = GetLastError();
		str = "Error! CloseOrder() fail. errno=" + err + "# " + ErrorDescription(err) + " ---- CloseOrder(): ticket=" + ticket + ", volume=" + DoubleToStr(volume, 5) + ", cp=" + DoubleToStr(cp, 5);
		Debug(-1, str);
	}
}

int tell_timeframe(string str) {
// tell_timeframe(): ֵ͵kͼʱ.
        string period[TimeFrameLen]={"zero", "M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN1"};
        int timeframe[]={0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200, -1};
        int i;

        for (i=0; i<TimeFrameLen; i++)
                if (str == period[i]) break;
        return(i);
}

string tell_timeframe_2(int n) {
// tell_timeframe_2(): ַ͵kͼʱ.
        string period[]={"zero", "M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN1", "Unknow"};
        int timeframe[TimeFrameLen]={0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
        int i;

        for (i=0; i<TimeFrameLen; i++)
                if (n == timeframe[i]) break;
        return(period[i]);
}

/*
int tell_timeframe_3(int n) {
// tell_timeframe_3(): ֵ͵, kͼʱ.
        int timeframe[TimeFrameLen]={0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
        int i, j, period;
	bool flag;
	string str;

	if (n < 0)
		return(-1);
	period = Period() * Period_Multiple;
	for (i=0, flag=false; i < TimeFrameLen; i++)
		if (period <= timeframe[i]) {
			flag = true;
			break;
		}
	if (i >= TimeFrameLen)
		i = TimeFrameLen - 1;
	period = timeframe[i];
	if (flag == false) {
		str = TimeToStr(TimeCurrent()) + ", tell_timeframe_3(): Warning! Period()=" + Period() + ", n=" + n + ", i=" + i + "timeframe[i]=" + timeframe[i];
		Debug(1, str);
	}

	return(period);
}
*/

bool Signal_CloseOrder() {
// Signal_CloseOrder(): жδƽ, ǷҪƽ. Ҫ, true; Ҫ, false.
	bool flag=false;

	return(flag);
}

int Signal_OpenOrder() {
// Signal_OpenOrder(): ж/Ľ.
	int x=0;

	return(x);
}

